<?php

define('DATALIFEENGINE', true);
define('ROOT_DIR', '..');
define('ENGINE_DIR', dirname (__FILE__));

error_reporting(7);
ini_set('display_errors', true);
ini_set('html_errors', false);

include ENGINE_DIR.'/data/config.php';
require_once ENGINE_DIR.'/inc/mysql.php';
include_once ENGINE_DIR.'/data/dbconfig.php';
include_once ENGINE_DIR.'/modules/functions.php';
require_once ENGINE_DIR.'/inc/templates.class.php';
include_once ROOT_DIR.'/language/'.$config['langs'].'/website.lng';

if ($config['site_offline'] == "yes") die ("The site in offline mode");

check_xss ();

$tpl = new dle_template;
$tpl->dir =  ROOT_DIR.'/templates';
define('TEMPLATE_DIR', $tpl->dir);

$cat_info = get_vars ("category");

if (!$cat_info) {
$cat_info = array ();

$db->query("SELECT * FROM " . PREFIX . "_category ORDER BY posi ASC");
while($row = $db->get_row()){

   $cat_info[$row['id']] = array ();

     foreach ($row as $key => $value)
     {
       $cat_info[$row['id']][$key] = $value;
     }

}
set_vars ("category", $cat_info);
$db->free();
}

$user_group = get_vars ("usergroup");

if (!$user_group) {
  $user_group = array ();

  $db->query("SELECT * FROM " . USERPREFIX . "_usergroups ORDER BY id ASC");

  while($row = $db->get_row()){

   $user_group[$row['id']] = array ();

     foreach ($row as $key => $value)
     {
       $user_group[$row['id']][$key] = $value;
     }

  }
  set_vars ("usergroup", $user_group);
  $db->free();
}

$member_id['user_group'] = 5;

if (isset($_REQUEST['year']))      $year      = intval($_GET['year']); else $year = '';
if (isset($_REQUEST['month']))     $month     = $db->safesql(strip_tags (str_replace('/', '', $_GET['month']))); else $month = '';
if (isset($_REQUEST['day']))       $day       = $db->safesql(strip_tags (str_replace('/', '', $_GET['day']))); else $day = '';
if (isset($_REQUEST['user']))      $user      = $db->safesql(strip_tags (str_replace('/', '', urldecode($_GET['user'])))); else $user = '';
if (isset($_REQUEST['news_name'])) $news_name = $db->safesql(strip_tags (str_replace('/', '', $_GET['news_name']))); else $news_name = '';
if (isset($_REQUEST['newsid']))    $newsid    = intval($_GET['newsid']); else $newsid = 0;
if (isset($_REQUEST['news_page'])) $news_page = intval($_GET['news_page']); else $news_page = 0;
if (isset($_REQUEST['category']))  $category  = $db->safesql(strip_tags (str_replace('/', '', $_GET['category']))); else $category = '';

if (isset($_REQUEST['category'])) {
	if (substr($_GET['category'], -1, 1) == '/') $_GET['category'] = substr($_GET['category'], 0, -1);
	$category  = $db->safesql(strip_tags(end(explode('/',$_GET['category']))));
} else $category = '';

if ($category != '') $category_id = get_ID ($cat_info, $category); else $category_id = false;

header('Content-type: application/xml');
echo<<<XML
<?xml version="1.0" encoding="UTF-8"?>
<rss version="2.0" xmlns:dc="http://purl.org/dc/elements/1.1/">
<channel>
<title>{$config['home_title']}</title>
<link>{$config['http_home_url']}</link>
<language>ru</language>
<description>{$config['home_title']}</description>
<generator>DataLife Engine</generator>
XML;

$view_template = "rss";

$config['allow_cache'] = false;
$config['allow_banner'] = false;

$cstart = 0;

require_once ENGINE_DIR.'/engine.php';

echo $tpl->result['content'];

echo'</channel></rss>';
?>