<?php
require_once './engine/inc/templates.class.php';

$tpl = new dle_template;
$tpl->dir = './templates/'.$config['skin'];

$tpl->load_template('preview.css');

echo <<<HTML
<html dir=rtl><title>پيش نمايش مطالب</title>
<meta content="text/html; charset={$config['charset']}" http-equiv=Content-Type>
<style type="text/css">
{$tpl->copy_template}
</style>
<body><center>
HTML;

$tpl->clear();

echo <<<HTML
<script language="javascript" type="text/javascript">
<!--
function ShowBild(sPicURL) {
window.open('{$config['http_home_url']}engine/modules/imagepreview.php?image='+sPicURL, '', 'resizable=1,HEIGHT=200,WIDTH=200, scrollbars=yes');
                        }
//-->
</script>
HTML;

include(ENGINE_DIR.'/inc/parse.class.php');

$parse = new ParseFilter(Array(), Array(), 1, 1);

$full_story = $parse->process($_POST['full_story']);
$short_story = $parse->process($_POST['short_story']);
$title = stripslashes($parse->process($_POST['title']));

if ($config['allow_admin_wysiwyg'] == "yes" OR $allow_br != '1'){
$full_story = $parse->BB_Parse($full_story);
$short_story = $parse->BB_Parse($short_story);
} else {
$full_story = $parse->BB_Parse($full_story, false);
$short_story = $parse->BB_Parse($short_story, false);
}

		if (!count($category)) { $my_cat = "---"; $my_cat_link = "---";} else {

		$my_cat = array (); $my_cat_link = array ();
	
			foreach ($category as $element) {
				if ($element) { $my_cat[] = $cat[$element];
								$my_cat_link[] = "<a href=\"#\">{$cat[$element]}</a>";
				}
			}
		$my_cat = stripslashes(implode (', ', $my_cat));
		$my_cat_link = stripslashes(implode (', ', $my_cat_link));
		}


    $tpl->load_template('shortstory.tpl');

    $tpl->set('{title}', $title);
    $tpl->set('{views}', 0);
    $tpl->set('{date}', langdate($config['timestamp_active'], time()));
    $tpl->set('[link]',"<a href=#>");
    $tpl->set('[/link]',"</a>");
    $tpl->set('{comments-num}', 0);
    $tpl->set('[full-link]', "<a href=#>");
    $tpl->set('[/full-link]', "</a>");
    $tpl->set('[com-link]', "<a href=#>");
    $tpl->set('[/com-link]', "</a>");
	$tpl->set('{rating}', "");
	$tpl->set('{approve}', "");
	$tpl->set('{author}', "--");
    $tpl->set('{category}', $my_cat);
    $tpl->set('{favorites}', '');
    $tpl->set('{link-category}', $my_cat_link);
    if($cat_icon[$category[0]] != ""){ $tpl->set('{category-icon}', $cat_icon[$category[0]]); }
    else{ $tpl->set('{category-icon}', ""); }


    $tpl->set('[mail]',"");
    $tpl->set('[/mail]',"");
    $tpl->set('{news-id}', "ID Unknown");
    $tpl->set('{php-self}', $PHP_SELF);

	$tpl->set_block("'\[hide\](.*?)\[/hide\]'i","\\1");
	if ( stristr( $tpl->copy_template, "[group=" ) ) {
		$tpl->copy_template = preg_replace( "#\\[group=5\\](.*?)\\[/group\\]#is","", $tpl->copy_template);
		$tpl->copy_template = preg_replace( "#\\[group=(.+?)\\](.*?)\\[/group\\]#is","\\2", $tpl->copy_template);
	}
	$tpl->copy_template = preg_replace( "#\\[category=(.+?)\\](.*?)\\[/category\\]#is","\\2", $tpl->copy_template);

	$tpl->set_block("'\\[edit\\].*?\\[/edit\\]'si","");

    $xfieldsaction = "templatereplacepreview";
    $xfieldsinput = $tpl->copy_template;
    include(ENGINE_DIR.'/inc/xfields.php');
    $tpl->copy_template = $xfieldsoutput;

    $tpl->set('{short-story}', stripslashes($short_story));
    $tpl->set('{full-story}', stripslashes($full_story));
	$tpl->set('{THEME}', $config['http_home_url'].'templates/'.$config['skin']);


$tpl->copy_template = "<fieldset style=\"border-style:solid; border-width:1; border-color:black;\"><legend> <span style=\"font-size: 10px; font-family: Tahoma\">متن مطلب:</span> </legend>".$tpl->copy_template."</fieldset>";
$tpl->compile('shortstory');
echo $tpl->result['shortstory'];

    $tpl->load_template('fullstory.tpl');

	if((strlen($full_story) < 8) and (!eregi("\{short-story\}", $tpl->copy_template)) ){ $full_story = $short_story; }

    $tpl->set('{title}', $title);
    $tpl->set('{views}', 0);
    $tpl->set('{date}', langdate($config['timestamp_active'], time()));
    $tpl->set('[link]',"<a href=#>");
    $tpl->set('[/link]',"</a>");
    $tpl->set('{comments-num}', 0);
    $tpl->set('[full-link]', "<a href=#>");
    $tpl->set('[/full-link]', "</a>");
    $tpl->set('[com-link]', "<a href=#>");
    $tpl->set('[/com-link]', "</a>");
	$tpl->set('{rating}', "");
	$tpl->set('{author}', "--");
    $tpl->set('{category}', $my_cat);
    $tpl->set('{link-category}', $my_cat_link);
    $tpl->set('{related-news}', "");

    if($cat_icon[$category[0]] != ""){ $tpl->set('{category-icon}', "<img border=0 src=\"".$cat_icon[$category[0]]."\">"); }
    else{ $tpl->set('{category-icon}', ""); }

    $tpl->set('{pages}', '');
    $tpl->set('{favorites}', '');
    $tpl->set('[mail]',"");
    $tpl->set('[/mail]',"");
    $tpl->set('{poll}', '');
    $tpl->set('{news-id}', "ID Unknown");
    $tpl->set('{php-self}', $PHP_SELF);

	$tpl->set_block("'\[hide\](.*?)\[/hide\]'i","\\1");
	if ( stristr( $tpl->copy_template, "[group=" ) ) {
		$tpl->copy_template = preg_replace( "#\\[group=5\\](.*?)\\[/group\\]#is","", $tpl->copy_template);
		$tpl->copy_template = preg_replace( "#\\[group=(.+?)\\](.*?)\\[/group\\]#is","\\2", $tpl->copy_template);
	}
	$tpl->copy_template = preg_replace( "#\\[category=(.+?)\\](.*?)\\[/category\\]#is","\\2", $tpl->copy_template);

	$tpl->set_block("'\\[edit\\].*?\\[/edit\\]'si","");
	$tpl->set_block("'{banner_(.*?)}'si","");

    $tpl->set('[print-link]',"<a href=#>");
    $tpl->set('[/print-link]',"</a>");

    $xfieldsaction = "templatereplacepreview";
    $xfieldsinput = $tpl->copy_template;
    include(ENGINE_DIR.'/inc/xfields.php');
    $tpl->copy_template = $xfieldsoutput;

    $tpl->set('{short-story}', stripslashes($short_story));
    $tpl->set('{full-story}', stripslashes($full_story));
	$tpl->set('{THEME}', $config['http_home_url'].'templates/'.$config['skin']);


$tpl->copy_template = "<fieldset style=\"border-style:solid; border-width:1; border-color:black;\"><legend> <span style=\"font-size: 10px; font-family: Tahoma\">متن ادامه مطلب:</span> </legend>".$tpl->copy_template."</fieldset>";
$tpl->compile('fullstory');
echo $tpl->result['fullstory'];


?>
</center></body></html>